---
- name: create empty tls additional subject alternate names list
  ansible.builtin.set_fact:
    tls_san_list: []

- name: add controllers IP to tls additional subject alternate names list
  ansible.builtin.set_fact:
    tls_san_list:
      "{{ tls_san_list + [
       (hostvars[item].public_ip is defined) | ternary(
       hostvars[item].public_ip|default(''), hostvars[item].ansible_host)
       ] }}"
  loop: "{{ groups[kubernetes_rke2_control_group] }}"

- name: add computed Kubernetes main address
  ansible.builtin.set_fact:
    tls_san_list:
      "{{ tls_san_list + [kubernetes_main_address] }}"

- name: add extra address for vip internal
  ansible.builtin.set_fact:
    tls_san_list:
      "{{ tls_san_list + [kubernetes.extra_addresses.vip_internal] }}"
  when: kubernetes.extra_addresses.vip_internal is defined

- name: add extra address for vip external
  ansible.builtin.set_fact:
    tls_san_list:
      "{{ tls_san_list + [kubernetes.extra_addresses.vip_internal] }}"
  when: kubernetes.extra_addresses.vip_external is defined

- name: add extra sans addresses
  ansible.builtin.set_fact:
    tls_san_list:
      "{{ tls_san_list + kubernetes.extra_sans }}"
  when: kubernetes.extra_sans is defined

- name: add front loadbalancer internal IP
  ansible.builtin.set_fact:
    tls_san_list:
      "{{ tls_san_list + [kubernetes_rke2_front_loadbalancer.internal_ip] }}"
  when: kubernetes_rke2_front_loadbalancer.internal_ip is defined

- name: add front loadbalancer public IP
  ansible.builtin.set_fact:
    tls_san_list:
      "{{ tls_san_list + [kubernetes_rke2_front_loadbalancer.public_ip] }}"
  when: kubernetes_rke2_front_loadbalancer.public_ip is defined

- name: add internal loadbalancer IP
  ansible.builtin.set_fact:
    tls_san_list:
      "{{ tls_san_list + [kubernetes_rke2_internal_loadbalancer.internal_ip] }}"
  when: kubernetes_rke2_internal_loadbalancer.internal_ip is defined

- name: make the list using unique values
  ansible.builtin.set_fact:
    tls_san_list: "{{ tls_san_list | unique }}"
